package numeroaleatorio3;

import java.io.IOException;
import java.net.BindException;
import java.net.ServerSocket;
import java.net.Socket;

/**
 * Esta classe implementa um servidor simples que fica aguardando conexões de
 * clientes. Quando uma conexão é solicitada, o servidor lê do cliente a
 * quantidade de números aleatórios desejada e envia para o cliente
 * estes números aleatórios, terminando então a conexão.
 */
public class TerceiroServidorDeNumerosAleatorios {
    // Método que permite a execução da classe.

    public static void main(String[] args) {
        ServerSocket servidor;
        try {
            // Criamos a instância de ServerSocket que responderá por solicitações
            // à porta 9999.
            servidor = new ServerSocket(9999);
            // O servidor aguarda "para sempre" as conexões.
            while (true) {
                // Quando uma conexão é feita,
                Socket conexão = servidor.accept();
                // ... criamos um serviço para atender a esta conexão...
                ServicoDeNumerosAleatorios s = new ServicoDeNumerosAleatorios(conexão);
                // ... e executamos o serviço (que será executado independentemente).
                s.start();
            }
        } // Pode ser que a porta 9999 já esteja em uso !
        catch (BindException e) {
            System.out.println("Porta já em uso.");
        } // Pode ser que tenhamos um erro qualquer de entrada ou saída.
        catch (IOException e) {
            System.out.println("Erro de entrada ou saída.");
        }
    }
}
