/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package daytime;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.Socket;
import java.net.UnknownHostException;

/**
 * Esta classe implementa um cliente simples para o serviço daytime (porta 13).
 * A classe simplesmente cria um socket para um servidor (no exemplo,
 * localhost) usando aquela porta, obtém um BufferedReader (usando um
 * InputStreamReader a partir do InputStream da conexão) e lê uma linha do
 * servidor.
 */
public class ClienteDeDaytime {

    public static void main(String[] args) {
        String servidor = "localhost";
        // Tentamos fazer a conexão e ler uma linha...
        try {
            // O construtor desta classe espera um nome de servidor
            // (ou o seu IP, na forma de uma string) e o número da porta para conexão.
            Socket conexao = new Socket(servidor, 13);
            // A partir do socket podemos obter um InputStream, a partir deste um
            // InputStreamReader e partir deste, um BufferedReader.
            BufferedReader br =
                    new BufferedReader(
                    new InputStreamReader(conexao.getInputStream()));
            String linha = br.readLine();
            System.out.println("Agora são " + linha + " no servidor " + servidor);
            // Fechamos a conexão.
            br.close();
            conexao.close();
        } 
        // Se houve problemas com o nome do host... (O endereço IP do servidor
        // não puder ser encontrado)
        catch (UnknownHostException e) {
            System.out.println("O servidor não existe ou está fora do ar.");
        } // Se houve problemas genéricos de entrada e saída...
        catch (IOException e) {
            System.out.println("Erro de entrada e saída.");
        }
    }
}
