/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package invertestring;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.net.Socket;
import java.net.UnknownHostException;

/**
 * Esta classe implementa um cliente simples para o serviço echo (porta 7).
 * A classe simplesmente cria um socket para um servidor (no exemplo,
 * localhost) usando aquela porta, obtém um BufferedReader (usando um
 * InputStreamReader a partir do InputStream da conexão) e um BufferedWriter
 * (usando um OutputStreamWriter a partir do OutputStream da conexão), e repete
 * o seguinte laço:
 * 1 - Lê uma string do teclado
 * 2 - Envia esta string para o servidor
 * 3 - Lê uma string do servidor
 * 4 - Imprime a string lida do servidor
 * Se a string entrada via teclado for igual a um ponto (".") o laço será
 * interrompido.
 */
public class ClienteDeStringInvertida {

    public static void main(String[] args) {
        String servidor = "localhost";
        // Tentamos fazer a conexão e ler uma linha...
        try {
            System.out.println("CLIENTE STRING INVERTIDA");
            Socket conexão = new Socket(servidor, 10101);
            // A partir do socket podemos obter um InputStream, a partir deste um
            // InputStreamReader e partir deste, um BufferedReader.
            BufferedReader br =
                    new BufferedReader(
                    new InputStreamReader(conexão.getInputStream()));
            // A partir do socket podemos obter um OutputStream, a partir deste um
            // OutputStreamWriter e partir deste, um Bufferedwriter.
            BufferedWriter bw =
                    new BufferedWriter(
                    new OutputStreamWriter(conexão.getOutputStream()));
            // Executamos este laço "para sempre":
            while (true) {
                // Lemos uma linha do console.
                System.out.println("Digite a String:");
                String linhaEnviada = Keyboard.readString();
                // Se o usuário tiver digitado Cancel, saímos do laço.
                if (linhaEnviada.equals(".")) {
                    break;
                }
                // Enviamos a linha para o servidor.
                bw.write(linhaEnviada);
                // Notem que após enviar uma string para o servidor, é necessário executar
                // os métodos newLine e flush da classe BufferedWriter para que os bytes
                // correspondentes à string sejam realmente enviados.
                bw.newLine();
                bw.flush();
                // Lemos uma linha a partir do servidor e a imprimimos no console.
                String linhaRecebida = br.readLine();
                System.out.println(linhaRecebida);
            }
            // Fechamos a conexão.
            br.close();
            bw.close();
            conexão.close();
        } // Se houve problemas com o nome do host...
        catch (UnknownHostException e) {
            System.out.println("O servidor não existe ou está fora do ar.");
        } // Se houve problemas genéricos de entrada e saída...
        catch (IOException e) {
            System.out.println("Erro de entrada e saída.");
        }
    }
}
