/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package livros;

import java.io.IOException;
import java.io.ObjectInputStream;
import java.net.Socket;
import java.net.UnknownHostException;

/**
 * Esta classe implementa um cliente simples para o serviço de livros.
 * Ele se conecta ao servidor (pela porta 12244) e recebe uma instância da classe
 * Livro enviada pelo servidor.
 */
public class ClienteDeLivros {

    public static void main(String[] args) {
        String servidor = "localhost";
        // Tentamos fazer a conexão e ler uma linha...
        try {
            Socket conexão = new Socket(servidor, 12244);
            // A partir do socket podemos obter um InputStream, a partir deste um
            // ObjectInputStream.
            ObjectInputStream dis = new ObjectInputStream(conexão.getInputStream());
            Livro umLivro = (Livro) dis.readObject();
            System.out.println("Livro obtido do servidor:");
            umLivro.imprime();
            // Fechamos a conexão.
            dis.close();
            conexão.close();
        } // Se houve problemas com o nome do host...
        catch (UnknownHostException e) {
            System.out.println("O servidor não existe ou está fora do ar.");
        } // Se houve problemas genéricos de entrada e saída...
        catch (IOException e) {
            System.out.println("Erro de entrada e saída.");
        } // Essa exceção poderia ocorrer se tivéssemos o cliente sendo executado em
        // outro computador e a classe Livro não tivesse sido distribuída.
        catch (ClassNotFoundException e) {
            System.out.println("A classe Livro não está presente no cliente.");
        }
    }
}
