package livros;

import java.io.Serializable;

/**
 * Para que instâncias de classes possam ser enviadas e recebidas por servidores e clientes
 * é necessário que elas sejam serializáveis. Para isto, basta declarar a classe como
 * implementando a interface Serializable, sem precisar implementar nenhum método adicional.
 * 
 */
public class Livro implements Serializable {

    private String título;
    private String autores;
    private int ano;

    public Livro(String t, String aut, int a) {
        título = t;
        autores = aut;
        ano = a;
    }

    public void imprime() {
        System.out.println(título + " (" + autores + ")," + ano);
    }
}
