/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package livros;

import java.io.IOException;
import java.io.ObjectOutputStream;
import java.net.BindException;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.ArrayList;

/**
 * Esta classe implementa um servidor simples que fica aguardando conexões de
 * clientes. Este servidor, quando conectado, envia uma instância da classe
 * Livro para o cliente e desconecta.
 */
public class ServidorDeLivros {

    // Estrutura que armazenará uma coleção de livros (instâncias da classe Livro).
    private static ArrayList<Livro> coleção;

    // Método que permite a execução da classe.
    public static void main(String[] args) {
        // Criamos uma coleção de livros.
        coleção = new ArrayList<Livro>();
        coleção.add(new Livro("Java 1.4 Game Programming",
                "Andrew Mulholland, Glen Murphy", 2003));
        coleção.add(new Livro("Developing Games In Java", "David Bracken", 2003));
        coleção.add(new Livro("Java 2 Game Programming", "Thomas Petchel", 2001));
        coleção.add(new Livro("Board And Table Games From Many Civilizations",
                "R.C.Bell", 1969));
        coleção.add(new Livro("A Gamut Of Games", "Sid Sackson", 1969));
        try {
            // Criamos a instância de ServerSocket que responderá por solicitações
            // à porta 12244.
            ServerSocket servidor = new ServerSocket(12244);
            // O servidor aguarda "para sempre" as conexões.
            while (true) {
                // Quando uma conexão é feita,
                Socket conexão = servidor.accept();
                // ... o servidor a processa.
                processaConexão(conexão);
            }
        } // Pode ser que a porta já esteja em uso !
        catch (BindException e) {
            System.out.println("Porta já em uso.");
        } // Pode ser que tenhamos um erro qualquer de entrada ou saída.
        catch (IOException e) {
            System.out.println("Erro de entrada ou saída.");
        }
    }

    // Este método atende a uma conexão feita a este servidor.
    private static void processaConexão(Socket conexão) {
        try {
            // Criamos uma stream para enviar instâncias de classes, usando a stream
            // de saída associado à conexão.
            ObjectOutputStream saída =
                    new ObjectOutputStream(conexão.getOutputStream());
            // Escolhemos um livro aleatoriamente.
            int qual = (int) (Math.random() * coleção.size());
            saída.writeObject(coleção.get(qual));
            // Ao terminar de atender a requisição, fechamos a stream de saída.
            saída.close();
            // Fechamos também a conexão.
            conexão.close();
        } // Se houve algum erro de entrada ou saída...
        catch (IOException e) {
            System.out.println("Erro atendendo a uma conexão !");
        }
    }
}
