/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package numeroaleatorio2;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.net.BindException;
import java.net.ServerSocket;
import java.net.Socket;

/**
 * Esta classe implementa um servidor simples que fica aguardando conexões de
 * clientes. Quando uma conexão é solicitada, o servidor lê do cliente a
 * quantidade de números aleatórios desejada e envia para o cliente
 * estes números aleatórios, terminando então a conexão.
 */
public class SegundoServidorDeNumerosAleatorios {
    // Método que permite a execução da classe.

    public static void main(String[] args) {
        ServerSocket servidor;
        try {
            // Criamos a instância de ServerSocket que responderá por solicitações
            // à porta 9999.
            servidor = new ServerSocket(9999);
            // O servidor aguarda "para sempre" as conexões.
            while (true) {
                // Quando uma conexão é feita,
                Socket conexão = servidor.accept();
                // ... o servidor a processa.
                processaConexão(conexão);
            }
        } // Pode ser que a porta 9999 já esteja em uso !
        catch (BindException e) {
            System.out.println("Porta já em uso.");
        } // Pode ser que tenhamos um erro qualquer de entrada ou saída.
        catch (IOException e) {
            System.out.println("Erro de entrada ou saída.");
        }
    }

    // Este método atende a uma conexão feita a este servidor.
    private static void processaConexão(Socket conexão) {
        try {
            // Criamos uma stream para receber valores nativos, usando a stream de entrada
            // associado à conexão.
            DataInputStream entrada =
                    new DataInputStream(conexão.getInputStream());
            // Criamos uma stream para enviar valores nativos, usando a stream de saída
            // associado à conexão.
            DataOutputStream saída =
                    new DataOutputStream(conexão.getOutputStream());
            // Lemos do cliente quantos números ele deseja.
            int quantidade = entrada.readInt();
            // Enviamos para o cliente os números.
            for (int q = 0; q < quantidade; q++) {
                double rand = Math.random();
                saída.writeDouble(rand);
                // Para demonstrar que realmente funciona, vamos imprimir um log.
                System.out.println("Acabo de enviar o número " + rand + " para o cliente "
                        + conexão.getRemoteSocketAddress());
            }
            // Ao terminar de atender a requisição, fechamos as streams.
            entrada.close();
            saída.close();
            // Fechamos também a conexão.
            conexão.close();
        } // Se houve algum erro de entrada ou saída...
        catch (IOException e) {
            System.out.println("Erro atendendo a uma conexão !");
        }
    }
}
