package numerosaleatorios;

import java.io.DataInputStream;
import java.io.IOException;
import java.net.Socket;
import java.net.UnknownHostException;

/**
 * Esta classe implementa um cliente simples para o serviço de números aleatórios.
 * Ele se conecta ao servidor (pela porta 9999) e recebe um número aleatório
 * gerado no servidor.
 */
public class ClienteDeNumerosAleatorios {

    public static void main(String[] args) {
        String servidor = "localhost";
        // Tentamos fazer a conexão e ler uma linha...
        try {
            Socket conexão = new Socket(servidor, 9999);
            // A partir do socket podemos obter um InputStream, a partir deste um
            // DataInputStream.
            DataInputStream dis = new DataInputStream(conexão.getInputStream());
            double valor = dis.readDouble();
            System.out.println("Li o valor " + valor + " do servidor " + servidor + ".");
            // Fechamos a conexão.
            dis.close();
            conexão.close();
        } // Se houve problemas com o nome do host...
        catch (UnknownHostException e) {
            System.out.println("O servidor não existe ou está fora do ar.");
        } // Se houve problemas genéricos de entrada e saída...
        catch (IOException e) {
            System.out.println("Erro de entrada e saída.");
        }
    }
}
